--Forceseek

--create a big table
SET NOCOUNT ON
GO

CREATE TABLE BIG_TABLE
(
COL1 INT IDENTITY NOT NULL,
COL2 TINYINT NOT NULL
)
GO

DECLARE @I INT
SET @I = 1
WHILE (@I <= 1000000)
BEGIN

IF (@I <=10)
INSERT INTO BIG_TABLE (COL2) VALUES (0)

IF (@I > 10 AND @I <= 100000)
INSERT INTO BIG_TABLE (COL2) VALUES (10)

IF (@I > 100000 AND @I <= 1000000)
INSERT INTO BIG_TABLE (COL2) VALUES (90)

SET @I = @I + 1
END
GO

--view data distribution
SELECT COL2, COUNT(*) AS REC_CNT
FROM BIG_TABLE
GROUP BY COL2
ORDER BY COL2;

--create noncustard index
CREATE NONCLUSTERED INDEX BIG_TABLE_IND_1 ON BIG_TABLE (COL2)
GO

--query for 90& of the table
SET SHOWPLAN_TEXT ON
GO
DECLARE @I INT
SET @I = 90
SELECT * FROM BIG_TABLE WHERE COL2 = @I
GO


--query for small amount of data
DECLARE @I INT
SET @I = 0
SELECT * FROM BIG_TABLE WHERE COL2 = @I
GO

--use of FORCESEEK
DECLARE @I INT
SET @I = 0
SELECT * FROM BIG_TABLE WITH (FORCESEEK) WHERE COL2 = @I
GO