CREATE TABLE StagedData
(ID int, UserName varchar(20))
GO 

CREATE TABLE RealData
(ID int, UserName varchar(20))
GO 

INSERT INTO StagedData VALUES (1, 'Tom') , (2, 'William') , (3, 'Kate')
GO 

MERGE RealData r
USING 
(SELECT ID, UserName FROM StagedData) staging
ON (r.ID = staging.ID)
WHEN MATCHED THEN UPDATE SET r.UserName = staging.UserName
WHEN TARGET NOT MATCHED THEN INSERT VALUES (ID, UserName)
WHEN SOURCE NOT MATCHED THEN DELETE;
GO
SELECT * FROM RealData
GO 

UPDATE StagedData SET UserName = 'Rachel' WHERE ID = 3
GO
MERGE RealData r
USING 
(SELECT ID, UserName FROM StagedData) staging
ON (r.ID = staging.ID)
WHEN MATCHED THEN UPDATE SET r.UserName = staging.UserName
WHEN TARGET NOT MATCHED THEN INSERT VALUES (ID, UserName)
WHEN SOURCE NOT MATCHED THEN DELETE;
GO
SELECT * FROM RealData
GO 


DELETE FROM StagedData WHERE ID = 3
GO
MERGE RealData r
USING 
(SELECT ID, UserName FROM StagedData) staging
ON (r.ID = staging.ID)
WHEN MATCHED THEN UPDATE SET r.UserName = staging.UserName
WHEN TARGET NOT MATCHED THEN INSERT VALUES (ID, UserName)
WHEN SOURCE NOT MATCHED THEN DELETE;
GO
SELECT * FROM RealData
GO 


DROP TABLE StagedData
GO
DROP TABLE RealData
GO 

